### CRDTs
- orbit-db is a CmRDT and implements an LWW-element-set
- operation-based CRDT
- (local biased) vector clocks for (partial) ordering, which in work quite smoothly

### Operation Logs
- each 'channel' is saved as a log of operations: add, put, del
- db operations are saved as an append-only log (linked lists)
    - TODO: op.json
- event log: take latest add or del for <hash> of content
- kv-store: take last put or del on <key>

### add/put IO:
==> Not expensive

1. Post (content, ipfs-hash)
`ipfs object get QmaAPEKDdaucQZRseJmKmWwZhgftBSwj8TD1xEomgcxo1X`
```json
{
  'Links': [],
  'Data': {
    'content': 'LambOfGod 347',
    'ts': 1456494484089
  }
}
```

2. Op (also Post, ipfs-hash)
```json
{
  'Links': [],
  'Data': {
    'op': 'PUT',
    'key': 'default',
    'value': 'QmaAPEKDdaucQZRseJmKmWwZhgftBSwj8TD1xEomgcxo1X',
    'meta':{
      'type': 'text',
      'size': -1,
      'from': 'writer',
      'ts': 1456494484094
    }
  }
}
```

3. Node ('latest heads', ipfs-hash)
`ipfs object get QmRzWAiFdLkdkwBDehzxhHdhfwbDKDnzqBnX53va58PuQu`
```json
{
  'Links': [],
  'Data': {
    'id': 'writer',
    'seq': 1301,
    'ver': 3,
    'items': {
      'writer.1301.0': 'QmNwREbsgGgiQPXxpvGanD55inFjUXjpEqjiPtpa39P7Mn',
      'writer.1301.1': 'QmQxndNEzWxKT5KRqRsty7JDGcbPVazaYPCqfB5z1mxmon',
      'writer.1301.2': 'QmUN1X97M2t8MX55H8VoPGXu2fLBpr91iCAzHkXudSMvDE'
    }
  }
}
```

4. Pubsub.publish (send to socket, network IO)
```json
{ 
  channel: '<channel name>', 
  hash: 'QmRzWAiFdLkdkwBDehzxhHdhfwbDKDnzqBnX53va58PuQu'
}
```

### get IO:
==> A little expensive

1. Payload (get from ipfs-hash, network IO)

### sync/merge IO:
==> Expensive!
TODO
